"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var _require = require('uuid'),
  uuidv4 = _require.v4;
var Keyframe = /*#__PURE__*/function () {
  /**
   * 一个关键帧（关键点）, 目前只支持线性插值
   * @param {number} timeOffset - 相对于素材起始点的时间偏移量
   * @param {number} value - 关键帧的值
   */
  function Keyframe(timeOffset, value) {
    _classCallCheck(this, Keyframe);
    this.kfId = uuidv4();
    this.timeOffset = timeOffset;
    this.values = [value];
  }
  return _createClass(Keyframe, [{
    key: "exportJson",
    value: function exportJson() {
      return {
        // 默认值
        curveType: "Line",
        graphID: "",
        left_control: {
          x: 0.0,
          y: 0.0
        },
        right_control: {
          x: 0.0,
          y: 0.0
        },
        // 自定义属性
        id: this.kfId,
        time_offset: this.timeOffset,
        values: this.values
      };
    }
  }]);
}();
var KeyframeProperty = Object.freeze({
  POSITION_X: "KFTypePositionX",
  // 位置x
  POSITION_Y: "KFTypePositionY",
  // 位置y
  ROTATION: "KFTypeRotation",
  // 旋转  0 - 360
  SCALE_X: "KFTypeScaleX",
  // 缩放x  5  - 0.1
  SCALE_Y: "KFTypeScaleY",
  // 缩放y  5  - 0.1
  UNIFORM_SCALE: "UNIFORM_SCALE",
  // 统一缩放  5  - 0.1
  ALPHA: "KFTypeAlpha",
  // 透明度 1:不透明 0:透明
  SATURATION: "KFTypeSaturation",
  // 饱和度
  CONTRAST: "KFTypeContrast",
  // 对比度
  BRIGHTNESS: "KFTypeBrightness",
  // 亮度
  VOLUME: "KFTypeVolume" // 音量
});
var KeyframeList = /*#__PURE__*/function () {
  /**
   * 关键帧列表, 记录与某个特定属性相关的一系列关键帧
   * @param {string} keyframeProperty - 关键帧对应的属性
   */
  function KeyframeList(keyframeProperty) {
    _classCallCheck(this, KeyframeList);
    this.listId = uuidv4();
    this.keyframeProperty = keyframeProperty;
    this.keyframes = [];
  }
  return _createClass(KeyframeList, [{
    key: "addKeyframe",
    value: function addKeyframe(timeOffset, value) {
      var keyframe = new Keyframe(timeOffset, value);
      this.keyframes.push(keyframe);
      this.keyframes.sort(function (a, b) {
        return a.timeOffset - b.timeOffset;
      });
    }
  }, {
    key: "exportJson",
    value: function exportJson() {
      return {
        id: this.listId,
        keyframe_list: this.keyframes.map(function (kf) {
          return kf.exportJson();
        }),
        material_id: "",
        property_type: this.keyframeProperty
      };
    }
  }]);
}();
module.exports = {
  Keyframe: Keyframe,
  KeyframeList: KeyframeList,
  KeyframeProperty: KeyframeProperty
};