"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var uuid = require('uuid');
var MaskMeta = /*#__PURE__*/function () {
  /**
   * 蒙版元数据
   * @param {string} name - 转场名称
   * @param {string} resource_type - 资源类型, 与蒙版形状相关
   * @param {string} resource_id - 资源ID
   * @param {string} effect_id - 效果ID
   * @param {string} md5 - MD5值
   * @param {number} default_aspect_ratio - 默认宽高比(宽高都是相对素材的比例)
   */
  function MaskMeta(name, resource_type, resource_id, effect_id, md5, default_aspect_ratio) {
    _classCallCheck(this, MaskMeta);
    this.name = name;
    this.resource_type = resource_type;
    this.resource_id = resource_id;
    this.effect_id = effect_id;
    this.md5 = md5;
    this.default_aspect_ratio = default_aspect_ratio;
  }
  return _createClass(MaskMeta, [{
    key: "getMaskMetaByTitle",
    value: function getMaskMetaByTitle(title) {
      var maskMetaMap = {
        "线性": new MaskMeta("线性", "line", "6791652175668843016", "82432976", "4c6a0ef5de6a844342d40330e00c59eb", 1.0),
        "镜面": new MaskMeta("镜面", "mirror", "6791699060140020232", "82432979", "95ac211c99063c41b86b9b63742f4a6d", 1.0),
        "圆形": new MaskMeta("圆形", "circle", "6791700663249146381", "82432977", "3ab1c47350d987c8ad415497e020a38b", 1.0),
        "矩形": new MaskMeta("矩形", "rectangle", "6791700809454195207", "82432980", "02b8999168d121538a98ea59127483ef", 1.0),
        "爱心": new MaskMeta("爱心", "heart", "6794051276482023949", "83244815", "27ae3c55bb97e470a75f61a8d34832bf", 1.115),
        "星形": new MaskMeta("星形", "pentagram", "6794051169434997255", "83244852", "7ff81ba985da9aae07b69c5b77ea7e9a", 1.05)
      };
      return maskMetaMap[title] || null;
    }
  }]);
}();
var Mask = /*#__PURE__*/function () {
  /**
   * 蒙版对象
   * @param {Object} mask_meta - 蒙版元数据
   * @param {number} cx - 中心X坐标
   * @param {number} cy - 中心Y坐标
   * @param {number} w - 宽度
   * @param {number} h - 高度
   * @param {number} ratio - 宽高比
   * @param {number} rot - 旋转角度
   * @param {boolean} inv - 是否反转
   * @param {number} feather - 羽化程度, 0-1
   * @param {number} round_corner - 矩形蒙版的圆角, 0-1
   */
  function Mask(mask_title) {
    _classCallCheck(this, Mask);
    var mask_meta = new MaskMeta().getMaskMetaByTitle(mask_title);
    this.config = {
      aspectRatio: mask_meta.default_aspect_ratio,
      centerX: 0.0,
      centerY: 0.0,
      feather: 0.0,
      height: 0.5,
      invert: false,
      rotation: 0.0,
      roundCorner: 0.0,
      width: 0.5
    };
    this.id = uuid.v4();
    this.name = mask_meta.name;
    this.platform = "all";
    this.position_info = "";
    this.resource_type = mask_meta.resource_type;
    this.resource_id = mask_meta.resource_id;
    this.type = "mask";
  }
  return _createClass(Mask, [{
    key: "exportJson",
    value: function exportJson() {
      return {
        config: {
          aspectRatio: this.aspect_ratio,
          centerX: this.center_x,
          centerY: this.center_y,
          feather: this.feather,
          height: this.height,
          invert: this.invert,
          rotation: this.rotation,
          roundCorner: this.round_corner,
          width: this.width
        },
        id: this.global_id,
        name: this.mask_meta.name,
        platform: "all",
        position_info: "",
        resource_type: this.mask_meta.resource_type,
        resource_id: this.mask_meta.resource_id,
        type: "mask"
        // 不导出path字段
      };
    }
  }]);
}();
module.exports = {
  Mask: Mask,
  MaskMeta: MaskMeta
};