"use strict";

function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var fs = require('fs');
var path = require('path');
var _require = require('uuid'),
  uuidv4 = _require.v4;

// 通用JSON文件读取方法（与texiao.js保持一致）
function readAllJsonFiles() {
  try {
    var directoryPath = __dirname;
    var files = fs.readdirSync(directoryPath);
    var jsonFiles = files.filter(function (file) {
      return path.extname(file).toLowerCase() === '.json';
    });
    return jsonFiles.map(function (file) {
      var filePath = path.join(directoryPath, file);
      var data = fs.readFileSync(filePath, 'utf8');
      return JSON.parse(data);
    });
  } catch (err) {
    console.error("Error reading JSON files:", err);
    throw err;
  }
}

// mode = 0 非vip  mode = 1 vip  mode = 2 all 
function get_all_audio_effects() {
  var mode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var vip_effects = [];
  var effects = [];
  var contents = readAllJsonFiles();
  var _iterator = _createForOfIteratorHelper(contents),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var content = _step.value;
      // 假设音频特效数据路径为 CategoryAudioEffects.AudioEffects
      var tmp_effects = content.data.effect_item_list;
      var _iterator2 = _createForOfIteratorHelper(tmp_effects),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var effect = _step2.value;
          var adjust_params = [];
          if (effect.common_attr.sdk_extra) {
            adjust_params = JSON.parse(effect.common_attr.sdk_extra)['setting']['audio_effect_parameters_change'];
          }
          // let aps = []
          var _iterator3 = _createForOfIteratorHelper(adjust_params),
            _step3;
          try {
            for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
              var ap = _step3.value;
              ap['name'] = ap['sliderName'];
              ap['max_value'] = ap['maxValue'];
              ap['min_value'] = ap['minValue'];
              ap['value'] = ap['defaultValue'];
              ap['default_value'] = ap['defaultValue'];
              // aps.push(ap)
            }
          } catch (err) {
            _iterator3.e(err);
          } finally {
            _iterator3.f();
          }
          var tmp = {
            "audio_adjust_params": adjust_params,
            "category_id": "sound_effect",
            "category_name": "场景音",
            "id": uuidv4(),
            "is_ugc": false,
            "name": effect.common_attr.title,
            "production_path": "",
            "resource_id": effect.common_attr.id,
            "speaker_id": "",
            "sub_type": 1,
            "time_range": {
              "duration": 0,
              "start": 0
            },
            "type": "audio_effect"
          };
          var extra = JSON.parse(effect.common_attr.extra || "{}");
          if (extra.is_vip) {
            tmp.is_vip = 1;
            vip_effects.push(tmp);
          } else {
            tmp.is_vip = 0;
            effects.push(tmp);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return mode === 1 ? vip_effects : mode === 0 ? effects : [].concat(vip_effects, effects);
}
function find_audio_effect_by_title(title) {
  var effects = get_all_audio_effects(2);
  var _iterator4 = _createForOfIteratorHelper(effects),
    _step4;
  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var effect = _step4.value;
      if (effect.name === title) {
        return effect;
      }
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }
  return null;
}

// 测试代码（使用时取消注释）
// (async () => {
//     try {
//         const effect = await find_audio_effect_by_title('教堂')
//         console.log("Found audio effect:", effect);
//     } catch (err) {
//         console.error(err);
//     }
// })();

module.exports = {
  get_all_audio_effects: get_all_audio_effects,
  find_audio_effect_by_title: find_audio_effect_by_title
};