"use strict";

function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var fs = require('fs');
var path = require('path');
var _require = require('uuid'),
  uuidv4 = _require.v4;

/**
 * 读取当前目录下所有的 .json 文件并返回其内容的数组
 * @returns {Array<Object>} 包含所有 JSON 文件内容的数组
 */
function readAllJsonFiles() {
  try {
    var directoryPath = __dirname;
    var files = fs.readdirSync(directoryPath);
    var jsonFiles = files.filter(function (file) {
      return path.extname(file).toLowerCase() === '.json';
    });
    return jsonFiles.map(function (file) {
      var filePath = path.join(directoryPath, file);
      var data = fs.readFileSync(filePath, 'utf8');
      return JSON.parse(data);
    });
  } catch (err) {
    console.error("Error reading JSON files:", err);
    throw err;
  }
}

//mode = 0 非vip  mode = 1 vip  mode = 2 all 
function get_all_texiao_Effects() {
  var mode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var vip_effects = [];
  var effects = [];
  var contents = readAllJsonFiles();
  var _iterator = _createForOfIteratorHelper(contents),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var content = _step.value;
      var tmp_effects = content.data.CategoryEffects.Effects;
      var _iterator2 = _createForOfIteratorHelper(tmp_effects),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var effect = _step2.value;
          var adjust_params = [];
          if (effect.SdkExtra) {
            adjust_params = JSON.parse(effect.SdkExtra).setting.effect_adjust_params;
          }
          var tmp = {
            "adjust_params": adjust_params,
            "algorithm_artifact_path": "",
            "apply_target_type": 2,
            "apply_time_range": null,
            "category_id": "",
            "category_name": "",
            "common_keyframes": [],
            "disable_effect_faces": [],
            "effect_id": effect.EffectId,
            "formula_id": "",
            "id": uuidv4(),
            "name": effect.Name,
            "path": "",
            "platform": "all",
            "render_index": 0,
            "request_id": "",
            "resource_id": effect.ResourceId,
            "source_platform": 0,
            "time_range": null,
            "track_render_index": 0,
            "type": "video_effect",
            "value": 1.0,
            "version": "",
            "icon_url": effect.IconUrl.UrlList[0]
          };
          var extra = JSON.parse(effect.Extra);
          if (extra.is_vip) {
            tmp.is_vip = 1;
            vip_effects.push(tmp);
          } else {
            tmp.is_vip = 0;
            effects.push(tmp);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  if (mode == 0) {
    return effects;
  } else if (mode == 1) {
    return vip_effects;
  } else {
    return [].concat(vip_effects, effects);
  }
}
function find_texiao_animation_by_resource_id(resource_id) {
  var effects = get_all_texiao_Effects(2);
  var _iterator3 = _createForOfIteratorHelper(effects),
    _step3;
  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var info = _step3.value;
      if (info.resource_id == resource_id) {
        return info;
      }
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
  return null;
}

// (async () => {
//     try {
//         const contents = await find_texiao_animation_by_resource_id('7348707427165934107')
//         console.log(" contents:", contents);
//     } catch (err) {
//         console.error(err);
//     }
// })();

module.exports = {
  get_all_texiao_Effects: get_all_texiao_Effects,
  find_texiao_animation_by_resource_id: find_texiao_animation_by_resource_id
};