"use strict";

function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var fs = require('fs');
var path = require('path');
var _require = require('uuid'),
  uuidv4 = _require.v4;
function readAllJsonFiles() {
  try {
    var directoryPath = __dirname;
    return readJsonFilesRecursively(directoryPath);
  } catch (err) {
    console.error("Error reading JSON files:", err);
    throw err;
  }
}
function readJsonFilesRecursively(dirPath) {
  var results = [];
  var files = fs.readdirSync(dirPath);
  var _iterator = _createForOfIteratorHelper(files),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var file = _step.value;
      var filePath = path.join(dirPath, file);
      var stat = fs.statSync(filePath);
      if (stat.isDirectory()) {
        results.push.apply(results, _toConsumableArray(readJsonFilesRecursively(filePath)));
      } else if (path.extname(file).toLowerCase() === '.json') {
        var data = fs.readFileSync(filePath, 'utf8');
        results.push(JSON.parse(data));
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return results;
}
function find_sticker_by_sticker_id(sticker_id) {
  var stickers = readAllJsonFiles();
  var _iterator2 = _createForOfIteratorHelper(stickers),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var sticker = _step2.value;
      if (sticker.data.effect_item_list.find(function (item) {
        return item.common_attr.effect_id == sticker_id;
      })) {
        return sticker.data.effect_item_list.find(function (item) {
          return item.common_attr.effect_id == sticker_id;
        });
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return null;
}
module.exports = {
  find_sticker_by_sticker_id: find_sticker_by_sticker_id
};